> ## Documentation Index
> Fetch the complete documentation index at: https://gcore.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Update virtual GPU cluster

> Update the name of an existing virtual GPU cluster.

Update tags for a virtual GPU cluster (and apply to all its nodes)
using JSON Merge Patch semantics (RFC 7386).
To add or update tags, provide key-value pairs.
To remove a tag, set its value to null.



## OpenAPI

````yaml /api-reference/services_documented/cloud_api.yaml patch /cloud/v3/gpu/virtual/{project_id}/{region_id}/clusters/{cluster_id}
openapi: 3.1.0
info:
  title: Gcore OpenAPI – Cloud API
  description: >-
    This OpenAPI is an aggregated OpenAPI specification that unifies all Gcore
    products into a single file. It covers Cloud, CDN, DNS, WAAP, DDoS
    Protection, Object Storage, Streaming, and FastEdge services.
  version: '2026-05-07T20:33:46.548242+00:00'
servers:
  - url: https://api.gcore.com
security:
  - APIKey: []
tags:
  - name: Bare Metal
    x-displayName: Bare Metal
  - name: Container as a Service
    x-displayName: Container as a Service
  - name: Cost Reports
    x-displayName: Cost Reports
  - name: DDoS Protection
    x-displayName: DDoS Protection
  - name: Everywhere Inference
    x-displayName: Everywhere Inference
  - name: Everywhere Inference Apps
    x-displayName: Everywhere Inference Apps
  - name: File Shares
    x-displayName: File Shares
  - name: Floating IPs
    x-displayName: Floating IPs
  - name: Function as a Service
    x-displayName: Function as a Service
  - name: GPU Bare Metal
    x-displayName: GPU Bare Metal
  - name: GPU Virtual
    x-displayName: GPU Virtual
  - name: IP Ranges
    x-displayName: IP Ranges
  - name: Images
    x-displayName: Images
  - name: Instances
    x-displayName: Instances
  - name: Load Balancers
    x-displayName: Load Balancers
  - name: Logging
    x-displayName: Logging
  - name: Managed Kubernetes
    x-displayName: Managed Kubernetes
  - name: Managed PostgreSQL
    x-displayName: Managed PostgreSQL
  - name: Networks
    x-displayName: Networks
  - name: Placement Groups
    x-displayName: Placement Groups
  - name: Projects
    x-displayName: Projects
  - name: Quotas
    x-displayName: Quotas
  - name: Regions
    x-displayName: Regions
  - name: Registry
    x-displayName: Registry
  - name: Reservations
    x-displayName: Reservations
  - name: Reserved IPs
    x-displayName: Reserved IPs
  - name: Routers
    x-displayName: Routers
  - name: SSH Keys
    x-displayName: SSH Keys
  - name: Secrets
    x-displayName: Secrets
  - name: Security Groups
    x-displayName: Security Groups
  - name: Snapshot Schedules
    x-displayName: Snapshot Schedules
  - name: Snapshots
    x-displayName: Snapshots
  - name: Tasks
    x-displayName: Tasks
  - name: User Actions
    x-displayName: User Actions
  - name: User Role Assignments
    x-displayName: User Role Assignments
  - name: Volumes
    x-displayName: Volumes
paths:
  /cloud/v3/gpu/virtual/{project_id}/{region_id}/clusters/{cluster_id}:
    patch:
      tags:
        - GPU Virtual
      summary: Update virtual GPU cluster
      description: |-
        Update the name of an existing virtual GPU cluster.

        Update tags for a virtual GPU cluster (and apply to all its nodes)
        using JSON Merge Patch semantics (RFC 7386).
        To add or update tags, provide key-value pairs.
        To remove a tag, set its value to null.
      operationId: VirtualClusterInstance.patch
      parameters:
        - in: path
          name: project_id
          required: true
          description: Project ID
          schema:
            description: Project ID
            example: 1
            examples:
              - 1
            title: Project Id
            type: integer
        - in: path
          name: region_id
          required: true
          description: Region ID
          schema:
            description: Region ID
            example: 7
            examples:
              - 7
            title: Region Id
            type: integer
        - in: path
          name: cluster_id
          required: true
          description: Cluster unique identifier
          schema:
            description: Cluster unique identifier
            example: 1aaaab48-10d0-46d9-80cc-85209284ceb4
            examples:
              - 1aaaab48-10d0-46d9-80cc-85209284ceb4
            format: uuid4
            title: Cluster Id
            type: string
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/UpdateClusterSerializer'
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/VirtualClusterSerializer'
      x-codeSamples:
        - lang: Python
          source: |-
            import os
            from gcore import Gcore

            client = Gcore(
                api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
            )
            gpu_virtual_cluster = client.cloud.gpu_virtual.clusters.update(
                cluster_id="1aaaab48-10d0-46d9-80cc-85209284ceb4",
                project_id=1,
                region_id=7,
            )
            print(gpu_virtual_cluster.id)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/G-Core/gcore-go\"\n\t\"github.com/G-Core/gcore-go/cloud\"\n\t\"github.com/G-Core/gcore-go/option\"\n)\n\nfunc main() {\n\tclient := gcore.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\tgpuVirtualCluster, err := client.Cloud.GPUVirtual.Clusters.Update(\n\t\tcontext.TODO(),\n\t\t\"1aaaab48-10d0-46d9-80cc-85209284ceb4\",\n\t\tcloud.GPUVirtualClusterUpdateParams{\n\t\t\tProjectID: gcore.Int(1),\n\t\t\tRegionID:  gcore.Int(7),\n\t\t},\n\t)\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", gpuVirtualCluster.ID)\n}\n"
components:
  schemas:
    UpdateClusterSerializer:
      properties:
        name:
          description: Cluster name
          example: gpu-cluster-1
          examples:
            - gpu-cluster-1
          maxLength: 63
          pattern: ^[a-zA-Z0-9][a-zA-Z 0-9._\-]{1,61}[a-zA-Z0-9._]$
          title: Name
          type: string
        tags:
          anyOf:
            - $ref: '#/components/schemas/UpdateTagsSerializer'
            - type: 'null'
          description: >-
            Update key-value tags using JSON Merge Patch semantics (RFC 7386).
            Provide key-value pairs to add or update tags. Set tag values to
            `null` to remove tags. Unspecified tags remain unchanged. Read-only
            tags are always preserved and cannot be modified.


            **Examples:**


            - **Add/update tags:** `{'tags': {'environment': 'production',
            'team': 'backend'}}` adds new tags or updates existing ones.

            - **Delete tags:** `{'tags': {'old_tag': null}}` removes specific
            tags.

            - **Remove all tags:** `{'tags': null}` removes all user-managed
            tags (read-only tags are preserved).

            - **Partial update:** `{'tags': {'environment': 'staging'}}` only
            updates specified tags.

            - **Mixed operations:** `{'tags': {'environment': 'production',
            'cost_center': 'engineering', 'deprecated_tag': null}}` adds/updates
            'environment' and 'cost_center' while removing 'deprecated_tag',
            preserving other existing tags.

            - **Replace all:** first delete existing tags with null values, then
            add new ones in the same request.
          examples:
            - my-tag: my-tag-value
              my-tag-to-remove: null
      title: UpdateClusterSerializer
      type: object
    VirtualClusterSerializer:
      properties:
        created_at:
          description: Cluster creation date time
          example: '2024-12-31T23:59:59Z'
          examples:
            - '2024-12-31T23:59:59Z'
          format: date-time
          title: Created At
          type: string
        flavor:
          description: Cluster flavor name
          example: g3-ai-32-192-1500-l40s-48-1
          examples:
            - g3-ai-32-192-1500-l40s-48-1
          title: Flavor
          type: string
        has_pending_changes:
          description: >-
            True if any server in the cluster has pending (not yet applied)
            settings changes
          example: false
          examples:
            - false
          title: Has Pending Changes
          type: boolean
        id:
          description: Cluster unique identifier
          example: 1aaaab48-10d0-46d9-80cc-85209284ceb4
          examples:
            - 1aaaab48-10d0-46d9-80cc-85209284ceb4
          format: uuid4
          title: Id
          type: string
        name:
          description: Cluster name
          example: my virtual gpu cluster
          examples:
            - my virtual gpu cluster
          title: Name
          type: string
        servers_count:
          description: Cluster servers count
          example: 2
          examples:
            - 2
          title: Servers Count
          type: integer
        servers_ids:
          description: List of cluster nodes
          example:
            - b4522653-fbcd-44a0-a949-541570a52281
            - e56192de-ed28-452a-b775-eeeacc795e3b
          examples:
            - - b4522653-fbcd-44a0-a949-541570a52281
              - e56192de-ed28-452a-b775-eeeacc795e3b
          items:
            format: uuid4
            type: string
          title: Servers Ids
          type: array
        servers_settings:
          $ref: '#/components/schemas/VirtualServerSettingsOutputSerializer'
        status:
          $ref: '#/components/schemas/GPUClusterStatus'
          description: Cluster status
          examples:
            - active
        tags:
          description: >-
            List of key-value tags associated with the resource. A tag is a
            key-value pair that can be associated with a resource, enabling
            efficient filtering and grouping for better organization and
            management. Some tags are read-only and cannot be modified by the
            user. Tags are also integrated with cost reports, allowing cost data
            to be filtered based on tag keys or values.
          example:
            - key: my-tag
              read_only: false
              value: my-tag-value
          examples:
            - - key: my-tag
                read_only: false
                value: my-tag-value
          items:
            $ref: '#/components/schemas/TagSerializer'
          title: Tags
          type: array
        updated_at:
          anyOf:
            - format: date-time
              type: string
            - type: 'null'
          description: Cluster update date time
          examples:
            - '2025-01-11T23:59:59Z'
          title: Updated At
      required:
        - id
        - name
        - status
        - flavor
        - tags
        - servers_count
        - created_at
        - updated_at
        - servers_ids
        - servers_settings
        - has_pending_changes
      title: VirtualClusterSerializer
      type: object
    UpdateTagsSerializer:
      patternProperties:
        ^[^\s=]+$:
          anyOf:
            - maxLength: 255
              minLength: 1
              pattern: ^[^ \t\n\r\f\v]([^\t\n\r\f\v]*[^ \t\n\r\f\v])?$
              type: string
            - type: 'null'
          description: >-
            Tag value. Maximum 255 characters. Cannot contain tabs, newlines,
            empty string or start/end with whitespace. Set to `null` in order to
            delete this tag.
          examples:
            - my-tag-value
      propertyNames:
        description: >-
          Tag key. Maximum 255 characters. Cannot contain spaces, tabs,
          newlines, empty string or '=' character.
        examples:
          - my-tag
        maxLength: 255
        minLength: 1
      title: UpdateTagsSerializer
      type: object
    VirtualServerSettingsOutputSerializer:
      properties:
        file_shares:
          description: List of file shares mounted across the cluster.
          items:
            $ref: '#/components/schemas/FileShareMountSerializer'
          title: File Shares
          type: array
        interfaces:
          items:
            discriminator:
              mapping:
                any_subnet:
                  $ref: '#/components/schemas/AnySubnetInterfaceOutputSerializer'
                external:
                  $ref: '#/components/schemas/ExternalInterfaceOutputSerializer'
                subnet:
                  $ref: '#/components/schemas/SubnetInterfaceOutputSerializer'
              propertyName: type
            oneOf:
              - $ref: '#/components/schemas/ExternalInterfaceOutputSerializer'
              - $ref: '#/components/schemas/SubnetInterfaceOutputSerializer'
              - $ref: '#/components/schemas/AnySubnetInterfaceOutputSerializer'
          title: Interfaces
          type: array
        security_groups:
          description: Security groups
          example:
            - id: ae74714c-c380-48b4-87f8-758d656cdad6
              name: default
          examples:
            - - id: ae74714c-c380-48b4-87f8-758d656cdad6
                name: default
          items:
            $ref: '#/components/schemas/GroupSecurityGroupSerializer'
          title: Security Groups
          type: array
        ssh_key_name:
          anyOf:
            - type: string
            - type: 'null'
          description: SSH key name
          examples:
            - my-ssh-key
          title: Ssh Key Name
        user_data:
          anyOf:
            - type: string
            - type: 'null'
          description: Optional custom user data
          examples:
            - eyJ0ZXN0IjogImRhdGEifQ==
          title: User Data
        volumes:
          description: List of volumes
          items:
            $ref: '#/components/schemas/VolumeOutputSerializer'
          title: Volumes
          type: array
      required:
        - user_data
        - ssh_key_name
        - interfaces
        - file_shares
        - security_groups
        - volumes
      title: VirtualServerSettingsOutputSerializer
      type: object
    GPUClusterStatus:
      enum:
        - active
        - creating
        - degraded
        - deleting
        - error
        - rebooting
        - rebuilding
        - resizing
        - shutoff
      title: GPUClusterStatus
      type: string
    TagSerializer:
      description: >-
        A tag is a key-value pair that can be associated with a resource,

        enabling efficient filtering and grouping for better organization and
        management.

        Some tags are read-only and cannot be modified by the user.

        Tags are also integrated with cost reports, allowing cost data to be
        filtered based on tag keys or values.
      properties:
        key:
          description: >-
            Tag key. Maximum 255 characters. Cannot contain spaces, tabs,
            newlines, empty string or '=' character.
          example: my-tag
          examples:
            - my-tag
          title: Key
          type: string
        read_only:
          description: If true, the tag is read-only and cannot be modified by the user
          example: false
          examples:
            - false
          title: Read Only
          type: boolean
        value:
          description: >-
            Tag value. Maximum 255 characters. Cannot contain spaces, tabs,
            newlines, empty string or '=' character.
          example: my-tag-value
          examples:
            - my-tag-value
          title: Value
          type: string
      required:
        - key
        - value
        - read_only
      title: TagSerializer
      type: object
    FileShareMountSerializer:
      properties:
        id:
          description: Unique identifier of the file share in UUID format.
          example: a3f2d1b8-45e6-4f8a-bb5d-19dbf2cd7e9a
          examples:
            - a3f2d1b8-45e6-4f8a-bb5d-19dbf2cd7e9a
          format: uuid4
          title: Id
          type: string
        mount_path:
          description: >-
            Absolute mount path inside the system where the file share will be
            mounted.
          example: /mnt/vast
          examples:
            - /mnt/vast
          title: Mount Path
          type: string
      required:
        - id
        - mount_path
      title: FileShareMountSerializer
      type: object
    AnySubnetInterfaceOutputSerializer:
      properties:
        floating_ip:
          anyOf:
            - $ref: '#/components/schemas/NewFloatingIpInterfaceSerializer'
            - type: 'null'
          description: Floating IP config for this subnet attachment
        ip_address:
          anyOf:
            - type: string
            - type: 'null'
          description: Fixed IP address
          examples:
            - 192.168.6.9
          title: Ip Address
        ip_family:
          description: 'Which subnets should be selected: IPv4, IPv6, or use dual stack'
          enum:
            - dual
            - ipv4
            - ipv6
          example: ipv4
          examples:
            - ipv4
          title: Ip Family
          type: string
        name:
          anyOf:
            - maxLength: 37
              type: string
            - type: 'null'
          description: Interface name
          title: Name
        network_id:
          description: >-
            Network ID the subnet belongs to. Port will be plugged in this
            network
          example: 59905c8e-2619-420a-b046-536096473370
          examples:
            - 59905c8e-2619-420a-b046-536096473370
          title: Network Id
          type: string
        type:
          const: any_subnet
          title: Type
          type: string
      required:
        - network_id
        - name
        - type
        - ip_family
        - ip_address
        - floating_ip
      title: AnySubnetInterfaceOutputSerializer
      type: object
    ExternalInterfaceOutputSerializer:
      properties:
        ip_family:
          description: 'Which subnets should be selected: IPv4, IPv6, or use dual stack.'
          enum:
            - dual
            - ipv4
            - ipv6
          example: ipv4
          examples:
            - ipv4
          title: Ip Family
          type: string
        name:
          anyOf:
            - type: string
            - type: 'null'
          description: Interface name
          examples:
            - eth0
          title: Name
        type:
          const: external
          title: Type
          type: string
      required:
        - type
        - ip_family
        - name
      title: ExternalInterfaceOutputSerializer
      type: object
    SubnetInterfaceOutputSerializer:
      properties:
        floating_ip:
          anyOf:
            - $ref: '#/components/schemas/NewFloatingIpInterfaceSerializer'
            - type: 'null'
          description: Floating IP config for this subnet attachment
        name:
          anyOf:
            - maxLength: 37
              type: string
            - type: 'null'
          description: Interface name
          title: Name
        network_id:
          description: >-
            Network ID the subnet belongs to. Port will be plugged in this
            network
          example: 59905c8e-2619-420a-b046-536096473370
          examples:
            - 59905c8e-2619-420a-b046-536096473370
          title: Network Id
          type: string
        subnet_id:
          description: Port is assigned an IP address from this subnet
          example: e3c6ee77-48cb-416b-b204-11b492cc776e3
          examples:
            - e3c6ee77-48cb-416b-b204-11b492cc776e3
          format: uuid4
          title: Subnet Id
          type: string
        type:
          const: subnet
          title: Type
          type: string
      required:
        - network_id
        - name
        - type
        - subnet_id
        - floating_ip
      title: SubnetInterfaceOutputSerializer
      type: object
    GroupSecurityGroupSerializer:
      properties:
        id:
          description: Security group ID
          example: ae74714c-c380-48b4-87f8-758d656cdad6
          examples:
            - ae74714c-c380-48b4-87f8-758d656cdad6
          title: Id
          type: string
        name:
          description: Security group name
          example: default
          examples:
            - default
          title: Name
          type: string
      required:
        - id
        - name
      title: GroupSecurityGroupSerializer
      type: object
    VolumeOutputSerializer:
      properties:
        boot_index:
          anyOf:
            - minimum: 0
              type: integer
            - type: 'null'
          description: Boot index of the volume
          examples:
            - 1
          title: Boot Index
        delete_on_termination:
          description: >-
            Flag indicating whether the volume is deleted on instance
            termination
          example: true
          examples:
            - true
          title: Delete On Termination
          type: boolean
        image_id:
          anyOf:
            - type: string
            - type: 'null'
          description: Image ID for the volume
          examples:
            - 3793c250-0b3b-4678-bab3-e11afbc29657
          title: Image Id
        name:
          description: Volume name
          example: my-data-disk
          examples:
            - my-data-disk
          pattern: ^[a-zA-Z0-9][a-zA-Z 0-9._\-]{1,61}[a-zA-Z0-9._]$
          title: Name
          type: string
        size:
          description: Volume size in GiB
          example: 100
          examples:
            - 100
          exclusiveMaximum: 102400
          exclusiveMinimum: 0
          title: Size
          type: integer
        tags:
          description: >-
            List of key-value tags associated with the resource. A tag is a
            key-value pair that can be associated with a resource, enabling
            efficient filtering and grouping for better organization and
            management. Some tags are read-only and cannot be modified by the
            user. Tags are also integrated with cost reports, allowing cost data
            to be filtered based on tag keys or values.
          example:
            - key: my-tag
              read_only: false
              value: my-tag-value
          examples:
            - - key: my-tag
                read_only: false
                value: my-tag-value
          items:
            $ref: '#/components/schemas/TagSerializer'
          title: Tags
          type: array
        type:
          $ref: '#/components/schemas/AllVolumeTypeEnum'
          description: Volume type
          examples:
            - ssd
      required:
        - size
        - type
        - name
        - tags
        - delete_on_termination
        - boot_index
        - image_id
      title: VolumeOutputSerializer
      type: object
    NewFloatingIpInterfaceSerializer:
      properties:
        source:
          const: new
          title: Source
          type: string
      required:
        - source
      title: NewFloatingIpInterfaceSerializer
      type: object
    AllVolumeTypeEnum:
      enum:
        - cold
        - ssd_hiiops
        - ssd_local
        - ssd_lowlatency
        - standard
        - ultra
      title: AllVolumeTypeEnum
      type: string
  securitySchemes:
    APIKey:
      description: >-
        API key for authentication. Make sure to include the word `apikey`,
        followed by a single space and then your token.

        Example: `apikey 1234$abcdef`
      type: apiKey
      in: header
      name: Authorization

````